#!/bin/bash

echo
echo ================
echo Tektrans - Finnet AD2MT post OS install script
echo ================
echo

read -p 'IP PeerVPN: ' ippeervpn < /dev/tty
if [ -z "$ippeervpn" ]; then
	echo "Invalid peervpn ip";
	exit
fi

set -x

sudo useradd komodo
sudo usermod -a -G dialout komodo
sudo usermod -a -G systemd-journal

sudo yum -y install epel-release
sudo yum -y groupinstall "Development Tools"
sudo yum -y remove nodejs
curl --silent --location https://rpm.nodesource.com/setup_8.x | sudo bash -
sudo yum -y install nodejs iftop vim-enhanced wget nmap traceroute net-tools telnet minicom iperf htop bwm-ng bash-completion bash-completion-extras whois bind-utils
sudo yum -y update
sudo npm install -g nodemon
sudo npm install -g mocha

mkdir src
cd ~src
wget https://peervpn.net/files/peervpn-0-044-linux-x86.tar.gz
tar xzf peervpn-0-044-linux-x86.tar.gz
cd peervpn-0-044
sudo install peervpn /usr/local/sbin/
sudo mkdir /etc/peervpn
sudo rm -f /etc/peervpn/tektrans.conf
sudo tee /etc/peervpn/tektrans.conf << EOF
networkname Tektrans
psk fc905de75a79a346abc58c256f950a7d3d015e99
enabletunneling yes
enablerelay yes
enableipv4 yes
enableipv6 no
interface pvpntektrans
initpeers 122.248.38.20 7010 128.199.161.36 7003
EOF

echo ifconfig4 $ippeervpn/24 | sudo tee -a /etc/peervpn/tektrans.conf

sudo tee /etc/systemd/system/peervpn@.service << EOF
[Unit]
Description=PeerVPN Node (%i)
After=syslog.target network.target
ConditionPathExists=/etc/peervpn/%i.conf

[Service]
Type=simple
ExecStart=/usr/local/sbin/peervpn /etc/peervpn/%i.conf

[Install]
WantedBy=multi-user.target
EOF

sudo tee /etc/systemd/system/komodo-gateway@.service << EOF
[Unit]
Description=Komodo Gateway- %i
After=syslog.target network.target

[Service]
Environment=KOMODO_DEBUG_MODEM="1"
Type=simple
WorkingDirectory=/home/komodo/gateways/%i
ExecStart=/usr/bin/node index.js
Restart=always
User=komodo
Group=komodo
StandardError=journal

[Install]
WantedBy=multi-user.target
EOF

sudo systemctl daemon-reload
sudo systemctl enable peervpn@tektrans
sudo systemctl restart peervpn@tektrans
